Bug 1588072 - [RFE] Client-side printing/export to PDF to support angular/react components
Summary: [RFE] Client-side printing/export to PDF to support angular/react components
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat CloudForms Management Engine
Classification: Red Hat
Component: UI - OPS
Version: 5.10.0
Hardware: Unspecified
OS: Unspecified
high
medium
Target Milestone: MVP
: 5.10.0
Assignee: Dávid Halász
QA Contact: Niyaz Akhtar Ansari
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-06-06 15:00 UTC by Dávid Halász
Modified: 2019-02-07 23:03 UTC (History)
5 users (show)

Fixed In Version: 5.10.0.3
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-02-07 23:03:00 UTC
Category: Feature
Cloudforms Team: CFME Core
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:0212 None None None 2019-02-07 23:03:08 UTC

Description Dávid Halász 2018-06-06 15:00:55 UTC
Description of problem:
The current export to PDF feature is fully implemented on the server side using a 3rd party tool. However, this can export only HTML elements that are not being rendered on the client-side, i.e. it's not possible to export angular/react components into PDF.

The solution for this problem would be to use the browser's native print/export to PDF feature and drop the unnecessary server-side PDF rendering.

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 3 CFME Bot 2018-06-11 07:48:06 UTC
New commit detected on ManageIQ/manageiq-ui-classic/master:

https://github.com/ManageIQ/manageiq-ui-classic/commit/5303854f8878a132b565bf6b670f8893a3e49f0c
commit 5303854f8878a132b565bf6b670f8893a3e49f0c
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Wed May 16 13:50:47 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Wed May 16 13:50:47 2018 -0400

    Use browser's native printing dialog when exporting summaries to PDF

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/assets/stylesheets/pdf/_summary.scss | 111 -
 app/assets/stylesheets/pdf_summary.css | 6 -
 app/assets/stylesheets/pdf_summary.scss | 101 +
 app/controllers/application_controller/report_downloads.rb | 7 +-
 app/helpers/application_helper.rb | 2 +-
 app/helpers/application_helper/toolbar/dashboard_summary_toggle_view.rb | 9 +-
 app/helpers/application_helper/toolbar/summary_view.rb | 9 +-
 app/helpers/application_helper/toolbar/x_summary_view.rb | 9 +-
 app/views/layouts/show_pdf.html.haml | 46 +-
 config/initializers/assets.rb | 2 +
 spec/controllers/application_controller/report_downloads_spec.rb | 4 +-
 11 files changed, 156 insertions(+), 150 deletions(-)

Comment 5 CFME Bot 2018-06-11 12:28:08 UTC
New commit detected on ManageIQ/manageiq-ui-classic/master:

https://github.com/ManageIQ/manageiq-ui-classic/commit/bb3bf6eb919ac51cc1b9b34961a135373cbb1c18
commit bb3bf6eb919ac51cc1b9b34961a135373cbb1c18
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 11 04:30:30 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 11 04:30:30 2018 -0400

    Make textual summary PDF views/layouts more generic for reusability

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/assets/stylesheets/pdf_summary.scss | 101 -
 app/assets/stylesheets/print.scss | 97 +
 app/controllers/application_controller/report_downloads.rb | 3 +-
 app/views/layouts/print.html.haml | 32 +
 app/views/layouts/print/textual_summary.html.haml | 9 +
 app/views/layouts/show_pdf.html.haml | 34 -
 config/initializers/assets.rb | 2 +-
 spec/controllers/application_controller/report_downloads_spec.rb | 4 +-
 8 files changed, 143 insertions(+), 139 deletions(-)

Comment 8 CFME Bot 2018-06-12 13:31:25 UTC
New commit detected on ManageIQ/manageiq/master:

https://github.com/ManageIQ/manageiq/commit/654203735a3fc597b0e6930a4fd1c00c25a378eb
commit 654203735a3fc597b0e6930a4fd1c00c25a378eb
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 11 05:07:44 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 11 05:07:44 2018 -0400

    Make user_timezone method for MiqReportResult public

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/models/miq_report_result.rb | 2 -
 1 file changed, 2 deletions(-)

Comment 9 CFME Bot 2018-06-13 07:53:10 UTC
New commit detected on ManageIQ/manageiq-ui-classic/master:

https://github.com/ManageIQ/manageiq-ui-classic/commit/55ef6a23a1e0016c4ebaa164a61bf6a5986f3526
commit 55ef6a23a1e0016c4ebaa164a61bf6a5986f3526
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Tue Jun 12 04:11:16 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Tue Jun 12 04:11:16 2018 -0400

    Client-side print/export to PDF for dashboard widgets

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/assets/stylesheets/print.scss | 108 +
 app/controllers/application_controller/report_downloads.rb | 14 +-
 app/presenters/widget_presenter.rb | 13 +-
 app/views/layouts/print/report.html.haml | 9 +
 4 files changed, 136 insertions(+), 8 deletions(-)

Comment 11 CFME Bot 2018-06-21 12:20:32 UTC
New commit detected on ManageIQ/manageiq-ui-classic/master:

https://github.com/ManageIQ/manageiq-ui-classic/commit/7e8cdfc9252d94f624ced923a75935230133d5d0
commit 7e8cdfc9252d94f624ced923a75935230133d5d0
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Tue Jun 12 06:47:43 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Tue Jun 12 06:47:43 2018 -0400

    Move report PDF generation logic to render_pdf from widget_to_pdf

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/controllers/application_controller/report_downloads.rb | 37 +-
 1 file changed, 15 insertions(+), 22 deletions(-)


https://github.com/ManageIQ/manageiq-ui-classic/commit/116c4e601b662b0370f1c48961d4cf821970784a
commit 116c4e601b662b0370f1c48961d4cf821970784a
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Tue Jun 12 06:48:35 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Tue Jun 12 06:48:35 2018 -0400

    Adjust buttons related to PDF generation to clientside printing

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/controllers/application_controller/report_downloads.rb | 7 +-
 app/helpers/application_helper/toolbar/chargeback_center.rb | 9 +-
 app/helpers/application_helper/toolbar/compare_view.rb | 11 +-
 app/helpers/application_helper/toolbar/drift_view.rb | 9 +-
 app/helpers/application_helper/toolbar/gtl_view.rb | 9 +-
 app/helpers/application_helper/toolbar/miq_capacity_view.rb | 9 +-
 app/helpers/application_helper/toolbar/x_gtl_view.rb | 9 +-
 spec/helpers/application_helper/toolbar_builder_spec.rb | 12 -
 8 files changed, 34 insertions(+), 41 deletions(-)

Comment 14 CFME Bot 2018-06-29 14:06:28 UTC
New commit detected on ManageIQ/manageiq/master:

https://github.com/ManageIQ/manageiq/commit/eddf15f724c55d68b025274bdbee9debd64907cc
commit eddf15f724c55d68b025274bdbee9debd64907cc
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 25 09:28:31 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 25 09:28:31 2018 -0400

    Return with HTML table instead of PDF in the saved report async task

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/models/miq_report_result.rb | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

Comment 15 CFME Bot 2018-06-29 14:08:21 UTC
New commits detected on ManageIQ/manageiq-ui-classic/master:

https://github.com/ManageIQ/manageiq-ui-classic/commit/e4f2ead0cc0fa4fe09380e6c76ab360076020703
commit e4f2ead0cc0fa4fe09380e6c76ab360076020703
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 25 09:17:03 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 25 09:17:03 2018 -0400

    Send the report HTML rows as an instance variable when printing

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/controllers/application_controller/report_downloads.rb | 2 +
 app/views/layouts/print/report.html.haml | 2 +-
 2 files changed, 3 insertions(+), 1 deletion(-)


https://github.com/ManageIQ/manageiq-ui-classic/commit/d16929763086aa35d253cc13ef2020b4fe36c536
commit d16929763086aa35d253cc13ef2020b4fe36c536
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 25 09:17:52 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 25 09:17:52 2018 -0400

    Use browser-native printing/PDF export for saved reports

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/controllers/application_controller/report_downloads.rb | 40 +-
 1 file changed, 29 insertions(+), 11 deletions(-)


https://github.com/ManageIQ/manageiq-ui-classic/commit/de08ef47d92de41908d229ea4de50faa469e8030
commit de08ef47d92de41908d229ea4de50faa469e8030
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 25 09:18:14 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 25 09:18:14 2018 -0400

    Update toolbar button for printing/PDF exporting saved reports

    https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/helpers/application_helper/toolbar/report_view.rb | 8 +-
 1 file changed, 4 insertions(+), 4 deletions(-)


https://github.com/ManageIQ/manageiq-ui-classic/commit/2da362c5ece611b240e60f2f36e1ba240662518a
commit 2da362c5ece611b240e60f2f36e1ba240662518a
Author:     Dávid Halász <dhalasz@redhat.com>
AuthorDate: Mon Jun 25 09:18:41 2018 -0400
Commit:     Dávid Halász <dhalasz@redhat.com>
CommitDate: Mon Jun 25 09:18:41 2018 -0400

    Remove unnecessary button classes that depend on PdfGenerator

    Fixes https://bugzilla.redhat.com/show_bug.cgi?id=1588072

 app/helpers/application_helper/button/pdf.rb | 5 -
 app/helpers/application_helper/button/render_report_pdf.rb | 3 -
 spec/helpers/application_helper/buttons/render_report_pdf_spec.rb | 4 -
 3 files changed, 12 deletions(-)

Comment 16 Niyaz Akhtar Ansari 2018-07-13 04:29:30 UTC
Tested and Verified in Version 5.10.0.3.20180705151325_ce4d2b5

Comment 17 errata-xmlrpc 2019-02-07 23:03:00 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:0212


Note You need to log in before you can comment on or make changes to this bug.